config/routes.rb
Rails.application.routes.draw do
  get 'purchase', to: 'purchase#index', as: 'purchase_index'
  post 'purchase', to: 'purchase#create', as: 'purchase_create'
  get 'purchase/:category', to: 'purchase#show', as: 'purchase_show'

  get 'purchases', to: 'purchase#index', as: 'purchases_index'
  post 'purchases', to: 'purchase#create', as: 'purchases_create'
  get 'purchases/:category', to: 'purchase#show', as: 'purchases_show'

  get 'entries/:id', to: 'entries#show', as: 'entries_show'
  post 'entries/:id', to: 'entries#update', as: 'entries_update'
  delete 'entries/:id', to: 'entries#delete', as: 'entries_delete'

  get 'default-categories', to: 'default_category#index', as: 'default_category_index'
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/default_category.rb
class DefaultCategory < ApplicationRecord
end

app/models/purchase.rb
class Purchase < ApplicationRecord
  before_create do
    default_category = DefaultCategory.find_by(store:)
    if category.nil? || category == 'None'
      self.category = default_category.category unless default_category.nil?
    elsif default_category.nil?
      DefaultCategory.new(store:, category:).save
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :null_session
end

app/controllers/default_category_controller.rb
class DefaultCategoryController < ApplicationController
  def index
    @default_categories = DefaultCategory.order(:category).all
  end
end

app/controllers/entries_controller.rb
class EntriesController < ApplicationController
  def show
    @entry = Purchase.find(params[:id])
  end

  def update
    @entry = Purchase.find(params[:id])

    @entry.store = params[:store]
    @entry.price = params[:price]
    @entry.category = params[:category]

    @entry.save

    redirect_to purchases_show_path(category: @entry.category)
  end

  def delete
    Purchase.find(params[:id]).delete
  end
end

app/controllers/purchase_controller.rb
require 'digest/sha1'
class PurchaseController < ApplicationController
  def index_to_hsl(index)
    "hsl(#{index * 150 % 256}, #{80 - index * 2}%, 40%)"
  end

  def created_after
    (year, month) = if params[:month]
                      params[:month].split('-')
                    else
                      [Time.now.year, Time.now.month]
                    end

    Time.new(year, month)
  end

  def created_before
    after = created_after

    (year, month) = if after.month < 12
                      [after.year, after.month + 1]
                    else
                      [after.year + 1, 1]
                    end

    Time.new(year, month)
  end

  def index
    @purchases = Purchase.select('SUM(price) as price',
                                 'category').group(:category).where(created_at: created_after...created_before)
    @purchases = @purchases.sort_by { |p| - p.price }
    @data = @purchases.each_with_object({}) do |e, h|
      h[e.category] = e.price
    end

    @colors = @data.map.with_index { |_k, i| index_to_hsl(i) }
  end

  def show
    @category = params[:category]

    @show_all = @category == '*'

    @purchases = if @show_all
                   Purchase.order(:created_at).where(created_at: created_after...created_before).all
                 else
                   Purchase.order(:created_at).where(category: @category,
                                                     created_at: created_after...created_before).all
                 end
  end

  def create
    purchase = Purchase.new(
      price: params[:price].to_i,
      store: params[:store],
      category: params[:category]
    )

    purchase.created_at = Time.parse(params[:created_at]) if params[:created_at]

    purchase.save
  end

  def total
    return @total if defined? @total

    @total = @purchases.map { |p| p.price }.sum
  end

  def display_month
    return params[:month] if params[:month]

    t = Time.now
    "#{t.year}-#{'%02d' % t.month}"
  end

  helper_method :total
  helper_method :display_month
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/default_category_helper.rb
module DefaultCategoryHelper
end

app/helpers/purchase_helper.rb
module PurchaseHelper
end

app/views/default_category/index.html.slim
table
  thead
    tr
      th Store
      th Category

  tbody
    - @default_categories.each do |default_category|
      tr
        td=default_category.store
        td=default_category.category

app/views/entries/show.html.slim
main
  ==form_with url: entries_update_path(@entry.id), method: 'post' do
    div style="display: flex; flex-direction: column; max-width: 270px;"
      label
        | Store
        input type="text" name="store" value=@entry.store

      label
        | Price
        input type="number" name="price" value=@entry.price

      label
        | Category
        input type="text" name="category" value=@entry.category

      input type="submit"

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Mousekeeper</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%# <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/water.css"> %>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/light.css">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/purchase/index.html.slim
h1 Purchase#index


==form_with url: purchase_index_path(), method: "get" do
  div x-data="{}"
    input x-on:change="$refs.submit.click()" name="month" type="month" value=display_month
    input x-show="false" x-ref="submit" type="submit" value="Search"

main.purchase-index
  section
    table
      thead
        tr
          th Category
          th Spent
          th %
      tbody
        - @data.each_pair do |key, value|
          - color = @colors[@data.find_index {|entry| entry[0] == key}]
          tr style="color: #{color}"
            td
              a href=purchase_show_path(key, {month: params[:month]}) style="color: #{color}"
                | #{key}
            td #{number_with_delimiter(value, delimiter: ',')} RSD
            td=value * 100/total
        
        tr
          td
            a href=purchase_show_path('*', {month: params[:month]})
              | Total
          td #{number_with_delimiter(total, delimiter: ',')} RSD
          td 100%

  section
    == pie_chart @data, donut: true, colors: @colors, thousands: ',', suffix: ' RSD', height: '500px', legend: 'bottom'

app/views/purchase/show.html.slim
main
  table
    thead
      tr
        th Date
        - if @show_all
          th Category
        th Store
        th Amount
        th
    tbody
      - @purchases.each do |p|
        tr x-data="{createdAt: new Date('#{p.created_at}').toLocaleDateString()}"
          td x-text="createdAt"
            | #{p.created_at.strftime('%F')}
          - if @show_all
            td=p.category
          td=p.store
          td #{number_with_delimiter(p.price, delimiter: ',')} RSD
          td
            a href=entries_show_path(p.id)
              | Edit
            span="/"
            a x-data="{}" @click="fetch($refs.form.action, {body: new FormData($refs.form), method: 'DELETE'})" href=request.fullpath
              | Delete
              ==form_with url:entries_delete_path(p.id), method: 'delete', html: {"x-ref": "form", style: "display: none;"}
                input style="display: none" type="text" name="id" value=p.id
                input type="submit" value="Delete"